diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/CMakeLists.txt ns-3.41/CMakeLists.txt
--- ns-3.40/CMakeLists.txt	2023-09-27 13:30:37.526838800 -0700
+++ ns-3.41/CMakeLists.txt	2024-02-09 14:44:07.721789000 -0800
@@ -1,7 +1,7 @@
 # ##############################################################################
 # Required CMake version            #
 # ##############################################################################
-cmake_minimum_required(VERSION 3.10..3.10)
+cmake_minimum_required(VERSION 3.13..3.13)
 
 # ##############################################################################
 # Project name                        #
@@ -12,8 +12,8 @@
 
 # minimum compiler versions
 set(AppleClang_MinVersion 11.0.0)
-set(Clang_MinVersion 6.0.0)
-set(GNU_MinVersion 8.0.0)
+set(Clang_MinVersion 10.0.0)
+set(GNU_MinVersion 9.0.0)
 
 # common options
 option(NS3_ASSERT "Enable assert on failure" OFF)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/doc/contributing/pickle-to-xml.py ns-3.41/doc/contributing/pickle-to-xml.py
--- ns-3.40/doc/contributing/pickle-to-xml.py	2023-09-27 13:30:37.534838700 -0700
+++ ns-3.41/doc/contributing/pickle-to-xml.py	2024-02-09 14:44:07.725788800 -0800
@@ -7,35 +7,41 @@
 # ...
 # </pages>
 
-import pickle
-import os
 import codecs
+import os
+import pickle
+
 
 def dump_pickles(out, dirname, filename, path):
-    with open(os.path.join(dirname, filename), 'r', encoding='utf-8') as f:
+    with open(os.path.join(dirname, filename), "r", encoding="utf-8") as f:
         data = pickle.load(f)
-    with codecs.open(data['current_page_name'] + '.frag', mode='w', encoding='utf-8') as fragment_file:
-        fragment_file.write(data['body'])
+    with codecs.open(
+        data["current_page_name"] + ".frag", mode="w", encoding="utf-8"
+    ) as fragment_file:
+        fragment_file.write(data["body"])
 
     out.write('  <page url="%s">\n' % path)
-    out.write('    <fragment>%s.frag</fragment>\n' % data['current_page_name'])
-    if data['prev'] is not None:
-        out.write('    <prev url="%s">%s</prev>\n' %
-                  (os.path.normpath(os.path.join(path, data['prev']['link'])),
-                   data['prev']['title']))
-    if data['next'] is not None:
-        out.write('    <next url="%s">%s</next>\n' %
-                  (os.path.normpath(os.path.join(path, data['next']['link'])),
-                   data['next']['title']))
-    out.write('  </page>\n')
-
-    if data['next'] is not None:
-        next_path = os.path.normpath(os.path.join(path, data['next']['link']))
-        next_filename = os.path.basename(next_path) + '.fpickle'
+    out.write("    <fragment>%s.frag</fragment>\n" % data["current_page_name"])
+    if data["prev"] is not None:
+        out.write(
+            '    <prev url="%s">%s</prev>\n'
+            % (os.path.normpath(os.path.join(path, data["prev"]["link"])), data["prev"]["title"])
+        )
+    if data["next"] is not None:
+        out.write(
+            '    <next url="%s">%s</next>\n'
+            % (os.path.normpath(os.path.join(path, data["next"]["link"])), data["next"]["title"])
+        )
+    out.write("  </page>\n")
+
+    if data["next"] is not None:
+        next_path = os.path.normpath(os.path.join(path, data["next"]["link"]))
+        next_filename = os.path.basename(next_path) + ".fpickle"
         dump_pickles(out, dirname, next_filename, next_path)
 
+
 import sys
 
-sys.stdout.write('<pages>\n')
-dump_pickles(sys.stdout, os.path.dirname(sys.argv[1]), os.path.basename(sys.argv[1]), '/')
-sys.stdout.write('</pages>')
+sys.stdout.write("<pages>\n")
+dump_pickles(sys.stdout, os.path.dirname(sys.argv[1]), os.path.basename(sys.argv[1]), "/")
+sys.stdout.write("</pages>")
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/doc/contributing/source/conf.py ns-3.41/doc/contributing/source/conf.py
--- ns-3.40/doc/contributing/source/conf.py	2023-09-27 13:30:55.802883400 -0700
+++ ns-3.41/doc/contributing/source/conf.py	2024-02-09 14:45:45.430484000 -0800
@@ -11,206 +11,203 @@
 # All configuration values have a default; values that are commented out
 # serve to show the default.
 
-import sys, os
+import os
+import sys
 
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
-#sys.path.insert(0, os.path.abspath('.'))
+# sys.path.insert(0, os.path.abspath('.'))
 
 # -- General configuration -----------------------------------------------------
 
 # If your documentation needs a minimal Sphinx version, state it here.
-#needs_sphinx = '1.0'
+# needs_sphinx = '1.0'
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.imgmath']
+extensions = ["sphinx.ext.imgmath"]
 
 # Add any paths that contain templates here, relative to this directory.
-templates_path = ['_templates']
+templates_path = ["_templates"]
 
 # The suffix of source filenames.
-source_suffix = '.rst'
+source_suffix = ".rst"
 
 # The encoding of source files.
-#source_encoding = 'utf-8-sig'
+# source_encoding = 'utf-8-sig'
 
 # The master toctree document.
-master_doc = 'index'
+master_doc = "index"
 
 # General information about the project.
-project = u'ns-3'
-copyright = u'2015, ns-3 project'
+project = "ns-3"
+copyright = "2015, ns-3 project"
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
 # built documents.
 #
 # The short X.Y version.
-version = 'ns-3.40'
+version = "ns-3.41"
 # The full version, including alpha/beta/rc tags.
-release = 'ns-3.40'
+release = "ns-3.41"
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
-#language = None
+# language = None
 
 # There are two options for replacing |today|: either, you set today to some
 # non-false value, then it is used:
-#today = ''
+# today = ''
 # Else, today_fmt is used as the format for a strftime call.
-#today_fmt = '%B %d, %Y'
+# today_fmt = '%B %d, %Y'
 
 # List of patterns, relative to source directory, that match files and
 # directories to ignore when looking for source files.
 exclude_patterns = []
 
 # The reST default role (used for this markup: `text`) to use for all documents.
-#default_role = None
+# default_role = None
 
 # If true, '()' will be appended to :func: etc. cross-reference text.
-#add_function_parentheses = True
+# add_function_parentheses = True
 
 # If true, the current module name will be prepended to all description
 # unit titles (such as .. function::).
-#add_module_names = True
+# add_module_names = True
 
 # If true, sectionauthor and moduleauthor directives will be shown in the
 # output. They are ignored by default.
-#show_authors = False
+# show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = "sphinx"
 
 # A list of ignored prefixes for module index sorting.
-#modindex_common_prefix = []
+# modindex_common_prefix = []
 
 
 # -- Options for HTML output ---------------------------------------------------
 
 # The theme to use for HTML and HTML Help pages.  See the documentation for
 # a list of builtin themes.
-html_theme = 'ns3_html_theme'
+html_theme = "ns3_html_theme"
 
 # Theme options are theme-specific and customize the look and feel of a theme
 # further.  For a list of options available for each theme, see the
 # documentation.
-#html_theme_options = {}
+# html_theme_options = {}
 
 # Add any paths that contain custom themes here, relative to this directory.
-html_theme_path = ['../..']
+html_theme_path = ["../.."]
 
 # The name for this set of Sphinx documents.  If None, it defaults to
 # "<project> v<release> documentation".
-html_title = 'Contributing'
+html_title = "Contributing"
 
 # A shorter title for the navigation bar.  Default is the same as html_title.
-#html_short_title = None
+# html_short_title = None
 
 # The name of an image file (relative to this directory) to place at the top
 # of the sidebar.
-#html_logo = None
+# html_logo = None
 
 # The name of an image file (within the static path) to use as favicon of the
 # docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
 # pixels large.
-#html_favicon = None
+# html_favicon = None
 
 # Add any paths that contain custom static files (such as style sheets) here,
 # relative to this directory. They are copied after the builtin static files,
 # so a file named "default.css" will overwrite the builtin "default.css".
-html_static_path = ['_static']
+html_static_path = ["_static"]
 
 # If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
 # using the given strftime format.
-html_last_updated_fmt = '%b %d, %Y %H:%M'
+html_last_updated_fmt = "%b %d, %Y %H:%M"
 
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
-#html_use_smartypants = True
+# html_use_smartypants = True
 
 # Custom sidebar templates, maps document names to template names.
-#html_sidebars = {}
+# html_sidebars = {}
 
 # Additional templates that should be rendered to pages, maps page names to
 # template names.
-#html_additional_pages = {}
+# html_additional_pages = {}
 
 # If false, no module index is generated.
-#html_domain_indices = True
+# html_domain_indices = True
 
 # If false, no index is generated.
-#html_use_index = True
+# html_use_index = True
 
 # If true, the index is split into individual pages for each letter.
-#html_split_index = False
+# html_split_index = False
 
 # If true, links to the reST sources are added to the pages.
-#html_show_sourcelink = True
+# html_show_sourcelink = True
 
 # If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
-#html_show_sphinx = True
+# html_show_sphinx = True
 
 # If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
-#html_show_copyright = True
+# html_show_copyright = True
 
 # If true, an OpenSearch description file will be output, and all pages will
 # contain a <link> tag referring to it.  The value of this option must be the
 # base URL from which the finished HTML is served.
-#html_use_opensearch = ''
+# html_use_opensearch = ''
 
 # This is the file name suffix for HTML files (e.g. ".xhtml").
-#html_file_suffix = None
+# html_file_suffix = None
 
 # Output file base name for HTML help builder.
-htmlhelp_basename = 'ns-3doc'
+htmlhelp_basename = "ns-3doc"
 
 
 # -- Options for LaTeX output --------------------------------------------------
 
 # The paper size ('letter' or 'a4').
-#latex_paper_size = 'letter'
+# latex_paper_size = 'letter'
 
 # The font size ('10pt', '11pt' or '12pt').
-#latex_font_size = '10pt'
+# latex_font_size = '10pt'
 
 # Grouping the document tree into LaTeX files. List of tuples
 # (source start file, target name, title, author, documentclass [howto/manual]).
 latex_documents = [
-  ('index', 'ns-3-contributing.tex', u'Contributing to ns-3',
-   u'ns-3 project', 'manual'),
+    ("index", "ns-3-contributing.tex", "Contributing to ns-3", "ns-3 project", "manual"),
 ]
 
 # The name of an image file (relative to this directory) to place at the top of
 # the title page.
-latex_logo = '../../ns3_html_theme/static/ns-3.png'
+latex_logo = "../../ns3_html_theme/static/ns-3.png"
 
 # For "manual" documents, if this is true, then toplevel headings are parts,
 # not chapters.
-#latex_use_parts = False
+# latex_use_parts = False
 
 # If true, show page references after internal links.
-#latex_show_pagerefs = False
+# latex_show_pagerefs = False
 
 # If true, show URL addresses after external links.
-#latex_show_urls = False
+# latex_show_urls = False
 
 # Additional stuff for the LaTeX preamble.
-latex_preamble = '\\usepackage{amssymb}'
+latex_preamble = "\\usepackage{amssymb}"
 
 # Documents to append as an appendix to all manuals.
-#latex_appendices = []
+# latex_appendices = []
 
 # If false, no module index is generated.
-#latex_domain_indices = True
+# latex_domain_indices = True
 
 
 # -- Options for manual page output --------------------------------------------
 
 # One entry per manual page. List of tuples
 # (source start file, name, description, authors, manual section).
-man_pages = [
-    ('index', 'ns-3-contributing', u'Contributing to ns-3',
-     [u'ns-3 project'], 1)
-]
+man_pages = [("index", "ns-3-contributing", "Contributing to ns-3", ["ns-3 project"], 1)]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/doc/installation/source/conf.py ns-3.41/doc/installation/source/conf.py
--- ns-3.40/doc/installation/source/conf.py	2023-09-27 13:30:55.802883400 -0700
+++ ns-3.41/doc/installation/source/conf.py	2024-02-09 14:45:45.430484000 -0800
@@ -11,206 +11,203 @@
 # All configuration values have a default; values that are commented out
 # serve to show the default.
 
-import sys, os
+import os
+import sys
 
 # If extensions (or modules to document with autodoc) are in another directory,
 # add these directories to sys.path here. If the directory is relative to the
 # documentation root, use os.path.abspath to make it absolute, like shown here.
-#sys.path.insert(0, os.path.abspath('.'))
+# sys.path.insert(0, os.path.abspath('.'))
 
 # -- General configuration -----------------------------------------------------
 
 # If your documentation needs a minimal Sphinx version, state it here.
-#needs_sphinx = '1.0'
+# needs_sphinx = '1.0'
 
 # Add any Sphinx extension module names here, as strings. They can be extensions
 # coming with Sphinx (named 'sphinx.ext.*') or your custom ones.
-extensions = ['sphinx.ext.imgmath']
+extensions = ["sphinx.ext.imgmath"]
 
 # Add any paths that contain templates here, relative to this directory.
-templates_path = ['_templates']
+templates_path = ["_templates"]
 
 # The suffix of source filenames.
-source_suffix = '.rst'
+source_suffix = ".rst"
 
 # The encoding of source files.
-#source_encoding = 'utf-8-sig'
+# source_encoding = 'utf-8-sig'
 
 # The master toctree document.
-master_doc = 'index'
+master_doc = "index"
 
 # General information about the project.
-project = u'ns-3'
-copyright = u'2018, ns-3 project'
+project = "ns-3"
+copyright = "2018, ns-3 project"
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
 # built documents.
 #
 # The short X.Y version.
-version = 'ns-3.40'
+version = "ns-3.41"
 # The full version, including alpha/beta/rc tags.
-release = 'ns-3.40'
+release = "ns-3.41"
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
-#language = None
+# language = None
 
 # There are two options for replacing |today|: either, you set today to some
 # non-false value, then it is used:
-#today = ''
+# today = ''
 # Else, today_fmt is used as the format for a strftime call.
-#today_fmt = '%B %d, %Y'
+# today_fmt = '%B %d, %Y'
 
 # List of patterns, relative to source directory, that match files and
 # directories to ignore when looking for source files.
 exclude_patterns = []
 
 # The reST default role (used for this markup: `text`) to use for all documents.
-#default_role = None
+# default_role = None
 
 # If true, '()' will be appended to :func: etc. cross-reference text.
-#add_function_parentheses = True
+# add_function_parentheses = True
 
 # If true, the current module name will be prepended to all description
 # unit titles (such as .. function::).
-#add_module_names = True
+# add_module_names = True
 
 # If true, sectionauthor and moduleauthor directives will be shown in the
 # output. They are ignored by default.
-#show_authors = False
+# show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = "sphinx"
 
 # A list of ignored prefixes for module index sorting.
-#modindex_common_prefix = []
+# modindex_common_prefix = []
 
 
 # -- Options for HTML output ---------------------------------------------------
 
 # The theme to use for HTML and HTML Help pages.  See the documentation for
 # a list of builtin themes.
-html_theme = 'ns3_html_theme'
+html_theme = "ns3_html_theme"
 
 # Theme options are theme-specific and customize the look and feel of a theme
 # further.  For a list of options available for each theme, see the
 # documentation.
-#html_theme_options = {}
+# html_theme_options = {}
 
 # Add any paths that contain custom themes here, relative to this directory.
-html_theme_path = ['../..']
+html_theme_path = ["../.."]
 
 # The name for this set of Sphinx documents.  If None, it defaults to
 # "<project> v<release> documentation".
-html_title = 'Installation guide'
+html_title = "Installation guide"
 
 # A shorter title for the navigation bar.  Default is the same as html_title.
-#html_short_title = None
+# html_short_title = None
 
 # The name of an image file (relative to this directory) to place at the top
 # of the sidebar.
-#html_logo = None
+# html_logo = None
 
 # The name of an image file (within the static path) to use as favicon of the
 # docs.  This file should be a Windows icon file (.ico) being 16x16 or 32x32
 # pixels large.
-#html_favicon = None
+# html_favicon = None
 
 # Add any paths that contain custom static files (such as style sheets) here,
 # relative to this directory. They are copied after the builtin static files,
 # so a file named "default.css" will overwrite the builtin "default.css".
-html_static_path = ['_static']
+html_static_path = ["_static"]
 
 # If not '', a 'Last updated on:' timestamp is inserted at every page bottom,
 # using the given strftime format.
-html_last_updated_fmt = '%b %d, %Y %H:%M'
+html_last_updated_fmt = "%b %d, %Y %H:%M"
 
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
-#html_use_smartypants = True
+# html_use_smartypants = True
 
 # Custom sidebar templates, maps document names to template names.
-#html_sidebars = {}
+# html_sidebars = {}
 
 # Additional templates that should be rendered to pages, maps page names to
 # template names.
-#html_additional_pages = {}
+# html_additional_pages = {}
 
 # If false, no module index is generated.
-#html_domain_indices = True
+# html_domain_indices = True
 
 # If false, no index is generated.
-#html_use_index = True
+# html_use_index = True
 
 # If true, the index is split into individual pages for each letter.
-#html_split_index = False
+# html_split_index = False
 
 # If true, links to the reST sources are added to the pages.
-#html_show_sourcelink = True
+# html_show_sourcelink = True
 
 # If true, "Created using Sphinx" is shown in the HTML footer. Default is True.
-#html_show_sphinx = True
+# html_show_sphinx = True
 
 # If true, "(C) Copyright ..." is shown in the HTML footer. Default is True.
-#html_show_copyright = True
+# html_show_copyright = True
 
 # If true, an OpenSearch description file will be output, and all pages will
 # contain a <link> tag referring to it.  The value of this option must be the
 # base URL from which the finished HTML is served.
-#html_use_opensearch = ''
+# html_use_opensearch = ''
 
 # This is the file name suffix for HTML files (e.g. ".xhtml").
-#html_file_suffix = None
+# html_file_suffix = None
 
 # Output file base name for HTML help builder.
-htmlhelp_basename = 'ns-3doc'
+htmlhelp_basename = "ns-3doc"
 
 
 # -- Options for LaTeX output --------------------------------------------------
 
 # The paper size ('letter' or 'a4').
-#latex_paper_size = 'letter'
+# latex_paper_size = 'letter'
 
 # The font size ('10pt', '11pt' or '12pt').
-#latex_font_size = '10pt'
+# latex_font_size = '10pt'
 
 # Grouping the document tree into LaTeX files. List of tuples
 # (source start file, target name, title, author, documentclass [howto/manual]).
 latex_documents = [
-  ('index', 'ns-3-installation.tex', u'ns-3 Installation Guide',
-   u'ns-3 project', 'manual'),
+    ("index", "ns-3-installation.tex", "ns-3 Installation Guide", "ns-3 project", "manual"),
 ]
 
 # The name of an image file (relative to this directory) to place at the top of
 # the title page.
-latex_logo = '../../ns3_html_theme/static/ns-3.png'
+latex_logo = "../../ns3_html_theme/static/ns-3.png"
 
 # For "manual" documents, if this is true, then toplevel headings are parts,
 # not chapters.
-#latex_use_parts = False
+# latex_use_parts = False
 
 # If true, show page references after internal links.
-#latex_show_pagerefs = False
+# latex_show_pagerefs = False
 
 # If true, show URL addresses after external links.
-#latex_show_urls = False
+# latex_show_urls = False
 
 # Additional stuff for the LaTeX preamble.
-latex_preamble = '\\usepackage{amssymb}'
+latex_preamble = "\\usepackage{amssymb}"
 
 # Documents to append as an appendix to all manuals.
-#latex_appendices = []
+# latex_appendices = []
 
 # If false, no module index is generated.
-#latex_domain_indices = True
+# latex_domain_indices = True
 
 
 # -- Options for manual page output --------------------------------------------
 
 # One entry per manual page. List of tuples
 # (source start file, name, description, authors, manual section).
-man_pages = [
-    ('index', 'ns-3-installation', u'ns-3 Installation',
-     [u'ns-3 project'], 1)
-]
+man_pages = [("index", "ns-3-installation", "ns-3 Installation", ["ns-3 project"], 1)]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/doc/manual/Makefile ns-3.41/doc/manual/Makefile
--- ns-3.40/doc/manual/Makefile	2023-09-27 13:30:37.534838700 -0700
+++ ns-3.41/doc/manual/Makefile	2024-02-09 14:44:07.729788800 -0800
@@ -77,6 +77,7 @@
 	figures/hotspot-setup.png \
 	figures/hotspot-top-down.png \
 	figures/perfetto-trace-cmake.png \
+	figures/time-consuming-event-handling.png \
 	figures/uprof-collect-callstack.png \
 	figures/uprof-profile-application.png \
 	figures/uprof-select-events.png \
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/doc/manual/source/conf.py ns-3.41/doc/manual/source/conf.py
--- ns-3.40/doc/manual/source/conf.py	2023-09-27 13:30:55.802883400 -0700
+++ ns-3.41/doc/manual/source/conf.py	2024-02-09 14:45:45.430484000 -0800
@@ -20,21 +20,22 @@
 # import sys
 # sys.path.insert(0, os.path.abspath('.'))
 
-import sys, os
+import os
+import sys
 
 # To change default code-block format in Latex to footnotesize (8pt)
 # Tip from https://stackoverflow.com/questions/9899283/how-do-you-change-the-code-example-font-size-in-latex-pdf-output-with-sphinx/9955928
 # Note:  sizes are \footnotesize (8pt), \small (9pt), and \normalsize (10pt).
 
-#from sphinx.highlighting import PygmentsBridge
-#from pygments.formatters.latex import LatexFormatter
+# from sphinx.highlighting import PygmentsBridge
+# from pygments.formatters.latex import LatexFormatter
 #
-#class CustomLatexFormatter(LatexFormatter):
+# class CustomLatexFormatter(LatexFormatter):
 #    def __init__(self, **options):
 #        super(CustomLatexFormatter, self).__init__(**options)
 #        self.verboptions = r"formatcom=\footnotesize"
 #
-#PygmentsBridge.latex_formatter = CustomLatexFormatter
+# PygmentsBridge.latex_formatter = CustomLatexFormatter
 
 # -- General configuration ------------------------------------------------
 
@@ -45,37 +46,37 @@
 # Add any Sphinx extension module names here, as strings. They can be
 # extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
 # ones.
-extensions = ['sphinx.ext.imgmath']
+extensions = ["sphinx.ext.imgmath"]
 
 # Add any paths that contain templates here, relative to this directory.
-templates_path = ['_templates']
+templates_path = ["_templates"]
 
 # The suffix(es) of source filenames.
 # You can specify multiple suffix as a list of string:
 #
 # source_suffix = ['.rst', '.md']
-source_suffix = '.rst'
+source_suffix = ".rst"
 
 # The encoding of source files.
 #
 # source_encoding = 'utf-8-sig'
 
 # The master toctree document.
-master_doc = 'index'
+master_doc = "index"
 
 # General information about the project.
-project = u'ns-3 project'
-copyright = u'2006-2019'
-#author = u'test'
+project = "ns-3 project"
+copyright = "2006-2019, ns-3 project"
+# author = u'test'
 
 # The version info for the project you're documenting, acts as replacement for
 # |version| and |release|, also used in various other places throughout the
 # built documents.
 #
 # The short X.Y version.
-version = u'ns-3.40'
+version = "ns-3.41"
 # The full version, including alpha/beta/rc tags.
-release = u'ns-3.40'
+release = "ns-3.41"
 
 # The language for content autogenerated by Sphinx. Refer to documentation
 # for a list of supported languages.
@@ -96,7 +97,7 @@
 # List of patterns, relative to source directory, that match files and
 # directories to ignore when looking for source files.
 # These patterns also affect html_static_path and html_extra_path
-exclude_patterns = ['_build', 'Thumbs.db', '.DS_Store']
+exclude_patterns = ["_build", "Thumbs.db", ".DS_Store"]
 
 # The reST default role (used for this markup: `text`) to use for all
 # documents.
@@ -118,7 +119,7 @@
 # show_authors = False
 
 # The name of the Pygments (syntax highlighting) style to use.
-pygments_style = 'sphinx'
+pygments_style = "sphinx"
 
 # A list of ignored prefixes for module index sorting.
 # modindex_common_prefix = []
@@ -135,7 +136,7 @@
 # The theme to use for HTML and HTML Help pages.  See the documentation for
 # a list of builtin themes.
 #
-html_theme = 'ns3_html_theme'
+html_theme = "ns3_html_theme"
 
 # Theme options are theme-specific and customize the look and feel of a theme
 # further.  For a list of options available for each theme, see the
@@ -144,13 +145,13 @@
 # html_theme_options = {}
 
 # Add any paths that contain custom themes here, relative to this directory.
-html_theme_path = ['../..']
+html_theme_path = ["../.."]
 
 # The name for this set of Sphinx documents.
 # "<project> v<release> documentation" by default.
 #
 # html_title = 'est vtest'
-html_title = 'Manual'
+html_title = "Manual"
 
 # A shorter title for the navigation bar.  Default is the same as html_title.
 #
@@ -170,7 +171,7 @@
 # Add any paths that contain custom static files (such as style sheets) here,
 # relative to this directory. They are copied after the builtin static files,
 # so a file named "default.css" will overwrite the builtin "default.css".
-html_static_path = ['_static']
+html_static_path = ["_static"]
 
 # Add any extra paths that contain custom files (such as robots.txt or
 # .htaccess) here, relative to this directory. These files are copied
@@ -182,7 +183,7 @@
 # bottom, using the given strftime format.
 # The empty string is equivalent to '%b %d, %Y'.
 #
-html_last_updated_fmt = '%b %d, %Y %H:%M'
+html_last_updated_fmt = "%b %d, %Y %H:%M"
 
 # If true, SmartyPants will be used to convert quotes and dashes to
 # typographically correct entities.
@@ -250,7 +251,7 @@
 # html_search_scorer = 'scorer.js'
 
 # Output file base name for HTML help builder.
-htmlhelp_basename = 'ns-3doc'
+htmlhelp_basename = "ns-3doc"
 
 # -- Options for LaTeX output ---------------------------------------------
 
@@ -258,11 +259,9 @@
     # The paper size ('letterpaper' or 'a4paper').
     #
     # 'papersize': 'letterpaper',
-
     # The font size ('10pt', '11pt' or '12pt').
     #
     # 'pointsize': '10pt',
-
     # Additional stuff for the LaTeX preamble.
     #
     # VerbatimBorderColor:  make the box around code samples blend into the background
@@ -275,10 +274,10 @@
     # See above to change the font size of verbatim code blocks
     #
     # 'preamble': '',
-    'preamble': u'''\\usepackage{amssymb}
+    "preamble": """\\usepackage{amssymb}
  \\definecolor{VerbatimBorderColor}{rgb}{1,1,1}
  \\renewcommand{\\sphinxcode}[1]{\\texttt{\\small{#1}}}
-'''
+"""
     # Latex figure (float) alignment
     #
     # 'figure_align': 'htbp',
@@ -288,14 +287,13 @@
 # (source start file, target name, title,
 #  author, documentclass [howto, manual, or own class]).
 latex_documents = [
-    ('index', 'ns-3-manual.tex', u'ns-3 Manual',
-     u'ns-3 project', 'manual'),
+    ("index", "ns-3-manual.tex", "ns-3 Manual", "ns-3 project", "manual"),
 ]
 
 # The name of an image file (relative to this directory) to place at the top of
 # the title page.
 #
-latex_logo = '../../ns3_html_theme/static/ns-3.png'
+latex_logo = "../../ns3_html_theme/static/ns-3.png"
 
 # If true, show page references after internal links.
 #
@@ -324,10 +322,7 @@
 
 # One entry per manual page. List of tuples
 # (source start file, name, description, authors, manual section).
-man_pages = [
-    ('index', 'ns-3-manual', u'ns-3 Manual',
-     [u'ns-3 project'], 1)
-]
+man_pages = [("index", "ns-3-manual", "ns-3 Manual", ["ns-3 project"], 1)]
 
 # If true, show URL addresses after external links.
 #
@@ -335,11 +330,11 @@
 
 # -- Options for texinfo output ---------------------------------------
 
-#texinfo_documents = [
+# texinfo_documents = [
 #    (master_doc, 'test', u'test Documentation',
 #    author, 'test', 'One line description of project.',
 #     'Miscellaneous'),
-#]
+# ]
 
 # Documents to append as an appendix to all manuals.
 #
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.40/doc/models/Makefile ns-3.41/doc/models/Makefile
--- ns-3.40/doc/models/Makefile	2023-09-27 13:30:37.570839000 -0700
+++ ns-3.41/doc/models/Makefile	2024-02-09 14:44:07.781789300 -0800
@@ -145,6 +145,8 @@
 	$(SRC)/wifi/doc/source/figures/ack-su-format.pdf \
 	$(SRC)/wifi/doc/source/figures/ack-su-format.png \
 	$(SRC)/wifi/doc/source/figures/assoc-manager.eps \
+	$(SRC)/wifi/doc/source/figures/emlsr-dl-txop.eps \
+	$(SRC)/wifi/doc/source/figures/emlsr-ul-txop.eps \
 	$(SRC)/wifi/doc/source/figures/mu-bar.pdf \
 	$(SRC)/wifi/doc/source/figures/mu-bar.png \
 	$(SRC)/wifi/doc/source/figures/aggr-mu-bar.pdf \
@@ -466,6 +468,8 @@
 	$(FIGURES)/energyFramework.eps \
 	$(FIGURES)/clear-channel.eps \
 	$(FIGURES)/assoc-manager.eps \
+	$(FIGURES)/emlsr-dl-txop.eps \
+	$(FIGURES)/emlsr-ul-txop.eps \
 	$(FIGURES)/nist-frame-success-rate.eps \
 	$(FIGURES)/nist-frame-success-rate-n.eps \
 	$(FIGURES)/nist-frame-success-rate-ac.eps \
@@ -545,6 +549,8 @@
 $(FIGURES)/nist-frame-success-rate-ac.pdf_width = 12cm
 $(FIGURES)/nist-frame-success-rate-ax.pdf_width = 12cm
 $(FIGURES)/assoc-manager.pdf_width = 12cm
+$(FIGURES)/emlsr-dl-txop.pdf_width = 12cm
+$(FIGURES)/emlsr-ul-txop.pdf_width = 12cm
 
 IMAGES_PNG = ${IMAGES_EPS:.eps=.png}
 IMAGES_PDF = ${IMAGES_EPS:.eps=.pdf}
